# Hatch

| | |
| --- | --- |
| CI/CD | [![CI - Test](https://github.com/ofek/hatch/actions/workflows/test.yml/badge.svg)](https://github.com/ofek/hatch/actions/workflows/test.yml) [![CD - Build Hatch](https://github.com/ofek/hatch/actions/workflows/build-hatch.yml/badge.svg)](https://github.com/ofek/hatch/actions/workflows/build-hatch.yml) [![CD - Build Hatchling](https://github.com/ofek/hatch/actions/workflows/build-hatchling.yml/badge.svg)](https://github.com/ofek/hatch/actions/workflows/build-hatchling.yml) |
| Docs | [![Docs - Release](https://github.com/ofek/hatch/actions/workflows/docs-release.yml/badge.svg)](https://github.com/ofek/hatch/actions/workflows/docs-release.yml) [![Docs - Dev](https://github.com/ofek/hatch/actions/workflows/docs-dev.yml/badge.svg)](https://github.com/ofek/hatch/actions/workflows/docs-dev.yml) |
| Package | [![PyPI - Version](https://img.shields.io/pypi/v/hatch.svg?logo=pypi&label=PyPI&logoColor=gold)](https://pypi.org/project/hatch/) [![PyPI - Downloads](https://img.shields.io/pypi/dm/hatchling.svg?color=blue&label=Downloads&logo=pypi&logoColor=gold)](https://pypi.org/project/hatch/) [![PyPI - Python Version](https://img.shields.io/pypi/pyversions/hatch.svg?logo=python&label=Python&logoColor=gold)](https://pypi.org/project/hatch/) |
| Meta | [![code style - black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black) [![types - Mypy](https://img.shields.io/badge/types-Mypy-blue.svg)](https://github.com/ambv/black) [![imports - isort](https://img.shields.io/badge/imports-isort-ef8336.svg)](https://github.com/pycqa/isort) [![License - MIT](https://img.shields.io/badge/license-MIT-9400d3.svg)](https://spdx.org/licenses/) [![GitHub Sponsors](https://img.shields.io/github/sponsors/ofek?logo=GitHub%20Sponsors&style=social)](https://github.com/sponsors/ofek) |

-----

Hatch is a modern, extensible Python project manager.

## Features

- Standardized build system with reproducible builds by default
- Robust environment management with support for custom scripts
- Easy publishing to PyPI or other sources
- Version management
- Configurable project generation with sane defaults
- Responsive CLI, ~2-3x faster than equivalent tools

## Documentation

The [documentation](https://ofek.dev/hatch/) is made with [Material for MkDocs](https://github.com/squidfunk/mkdocs-material) and is hosted by [GitHub Pages](https://docs.github.com/en/pages).

## License

Hatch is distributed under the terms of the [MIT](https://spdx.org/licenses/MIT.html) license.
